
-- return the window size
getWindowSize = getWindowSize or function()
	return 603, 314
end

-- create and lay out all the controls
createUI = createUI or function()

	createUICommon()
	setBannerContent( "nameOnly", 20, 200 )

	-- constants
	local kKnobSpace = 49

	local function knobGroup( LR, title )
		g = group( title )
		
		x = 0
		y = 0
		
		g:add( paramButton( "Enable " .. LR,					"Enable",			x, y, 45, 30 ) )
		x = x + 45 + kKnobSpace
		x = x - 0.5*kKnobSpace

		labelledDropDown( g, "Input Polarity " .. LR,			"Input",			x, y )
		x = x + kDropdownW + kKnobSpace
		x = x - 0.5*kKnobSpace

		smallKnobAndTextField( g, "Min Output Level " .. LR,	"Min Out",			x, y )
		x = x + kKnobSpace
		smallKnobAndTextField( g, "Max Output Level " .. LR,	"Max Out",			x, y )
		x = x + kKnobSpace
		
		return g
	end

	-- make groups and knobs
	--

	theKnobRenderer = smallKnobRenderer

	miscGroup = group( "OSC" )
	smallKnobAndTextField( miscGroup, "OSC Port Offset",	"Port",		0*kKnobSpace, 0 )
	miscGroup:setVisible( false )

	channel1Group = knobGroup( "L", "Channel 1" )
	channel2Group = knobGroup( "R", "Channel 2" )
	channel3Group = knobGroup( "3", "Channel 3" )
	channel4Group = knobGroup( "4", "Channel 4" )
	channel5Group = knobGroup( "5", "Channel 5" )
	channel6Group = knobGroup( "6", "Channel 6" )
	
	-- positions!

	local pad = 10

	local xbase = 20
	local ybase = 30
	local x = xbase
	local y = ybase
	
	channel5Group:setPosition( x, y )
	x = x + channel5Group:width() + pad
	channel6Group:setPosition( x, y )
	x = x + channel6Group:width() + pad
	miscGroup:setPosition( x, y )
	x = xbase
	y = y + channel6Group:height() + pad
	channel3Group:setPosition( x, y )
	x = x + channel3Group:width() + pad
	channel4Group:setPosition( x, y )
	x = xbase
	y = y + channel4Group:height() + pad
	channel1Group:setPosition( x, y )
	x = x + channel1Group:width() + pad
	channel2Group:setPosition( x, y )
	
	-- add directly positioned objects
	--

end		-- of createUI()
