
-- return the window size
getWindowSize = getWindowSize or function()
	return 510, 220
end

-- create and lay out all the controls
createUI = createUI or function()

	createUICommon()
	setBannerContent( "nameOnly", 20, 200 )

	-- constants
	local kKnobSpace = 69
	local kKnobSpaceV = 70
	local kTextW = 40

	local function knobGroup( LR, title )
		g = group( title )
		smallKnobAndTextField( g, "Output Positive " .. LR,		"Out 0->1",			0*kKnobSpace, 0*kKnobSpaceV, kTextW )
		smallKnobAndTextField( g, "Output Symmetric " .. LR,	"Out -1->1",		1*kKnobSpace, 0*kKnobSpaceV, kTextW )
		smallKnobAndTextField( g, "Multiplier " .. LR,			"Multiplier",		2*kKnobSpace, 0*kKnobSpaceV, kTextW )
		smallKnobAndTextField( g, "Input Add " .. LR,			"Input Add",		3*kKnobSpace, 0*kKnobSpaceV, kTextW )
		smallKnobAndTextField( g, "Input Multiply " .. LR,		"Input Mult",		4*kKnobSpace, 0*kKnobSpaceV, kTextW )
		smallKnobAndTextField( g, "Smoothing " .. LR,			"Smooth",			5*kKnobSpace, 0*kKnobSpaceV, kTextW )
		
		return g
	end

	-- make groups and knobs
	--

	theKnobRenderer = smallKnobRenderer

	miscGroup = group( "OSC" )
	smallKnobAndTextField( miscGroup, "OSC Port Offset",	"Port",		0*kKnobSpace, 0 )
	miscGroup:setVisible( false )

	leftGroup = knobGroup( "L", "Left Channel" )
	rightGroup = knobGroup( "R", "Right Channel" )

	-- positions!

	local xbase = windowEdgePad
	local ybase = windowEdgePad
	local x = xbase
	local y = ybase
	
	rightGroup:setPosition( x, y, true )
	x = x + rightGroup:width() + pad
	
	miscGroup:setPosition( x, y, true )
	x = x + miscGroup:width() + pad
	
	x = xbase
	y = y + rightGroup:height() + pad
	
	leftGroup:setPosition( x, y, true )
	x = x + leftGroup:width() + pad

	-- add directly positioned objects
	--

end		-- of createUI()
